/*******************************************************************************
/
/	File:			BzWindow.h
/
/	Description:	BWindow subclass that enable to redirect MessageReceived method
/				to another static function.
/				Usefull in project when you don't want to subclass a BWindow
/				or find 'dirty' to redirect the controls of the window to another BLooper.
/
/	Written by Anzani Andrea (oxygenum@tiscali.it)
/
*******************************************************************************/


#ifndef _BZWINDOW_H_
#define _BZWINDOW_H_
#include <Window.h>
#include <Message.h>

typedef bool (*RedirectFunc)(BMessage* msg,void* cookies);
	

class BzWindow: public BWindow{

	public:
		BzWindow(BRect frame,const char *title,window_type type,uint32 flags,uint32 workspaces = B_CURRENT_WORKSPACE):
			BWindow(frame,title,type,flags,workspaces),m_func(NULL){}
		
		/* to do : add all BWindow Constructors*/
		
		void	RedirectMessages(RedirectFunc m_fun,void* cookies=NULL);
		virtual void MessageReceived(BMessage *msg);
	
	private:
	
		RedirectFunc	m_func;
		void*				cookies;
		
		
};

#endif